class MD5
{
    public static int A, B, C, D;
    private static int words[] = new int[16];
    private static byte block[] = new byte[64];
    
    private static int F(int x, int y, int z)
    {
	return ((x & y) | (~x & z));
    }
    
    private static int G(int x, int y, int z)
    {
	return ((x & z) | (y & ~z));
    }
    
    private static int H(int x, int y, int z)
    {
	return (x ^ y ^ z);
    }
    
    private static int I(int x, int y, int z)
    {
	return (y ^ (x | ~z));
    }

    private static int rotL(int val, int numbits)
    {
	return ((val << numbits) | (val >>> (32 - numbits)));
    }

    private static void roundOne()
    {
	A = rotL(A + F(B, C, D) + words[ 0] + 0xD76AA478,  7) + B;
	D = rotL(D + F(A, B, C) + words[ 1] + 0xE8C7B756, 12) + A;
	C = rotL(C + F(D, A, B) + words[ 2] + 0x242070DB, 17) + D;
	B = rotL(B + F(C, D, A) + words[ 3] + 0xC1BDCEEE, 22) + C;
	
	A = rotL(A + F(B, C, D) + words[ 4] + 0xF57C0FAF,  7) + B;
	D = rotL(D + F(A, B, C) + words[ 5] + 0x4787C62A, 12) + A;
	C = rotL(C + F(D, A, B) + words[ 6] + 0xA8304613, 17) + D;
	B = rotL(B + F(C, D, A) + words[ 7] + 0xFD469501, 22) + C;
	
	A = rotL(A + F(B, C, D) + words[ 8] + 0x698098D8,  7) + B;
	D = rotL(D + F(A, B, C) + words[ 9] + 0x8B44F7AF, 12) + A;
	C = rotL(C + F(D, A, B) + words[10] + 0xFFFF5BB1, 17) + D;
	B = rotL(B + F(C, D, A) + words[11] + 0x895CD7BE, 22) + C;
	
	A = rotL(A + F(B, C, D) + words[12] + 0x6B901122,  7) + B;
	D = rotL(D + F(A, B, C) + words[13] + 0xFD987193, 12) + A;
	C = rotL(C + F(D, A, B) + words[14] + 0xA679438E, 17) + D;
	B = rotL(B + F(C, D, A) + words[15] + 0x49B40821, 22) + C;
    }

    private static void roundTwo()
    {
	A = rotL(A + G(B, C, D) + words[ 1] + 0xF61E2562,  5) + B;
	D = rotL(D + G(A, B, C) + words[ 6] + 0xC040B340,  9) + A;
	C = rotL(C + G(D, A, B) + words[11] + 0x265E5A51, 14) + D;
	B = rotL(B + G(C, D, A) + words[ 0] + 0xE9B6C7AA, 20) + C;

	A = rotL(A + G(B, C, D) + words[ 5] + 0xD62F105D,  5) + B;
	D = rotL(D + G(A, B, C) + words[10] + 0x02441453,  9) + A;
	C = rotL(C + G(D, A, B) + words[15] + 0xD8A1E681, 14) + D;
	B = rotL(B + G(C, D, A) + words[ 4] + 0xE7D3FBC8, 20) + C;

	A = rotL(A + G(B, C, D) + words[ 9] + 0x21E1CDE6,  5) + B;
	D = rotL(D + G(A, B, C) + words[14] + 0xC33707D6,  9) + A;
	C = rotL(C + G(D, A, B) + words[ 3] + 0xF4D50D87, 14) + D;
	B = rotL(B + G(C, D, A) + words[ 8] + 0x455A14ED, 20) + C;

	A = rotL(A + G(B, C, D) + words[13] + 0xA9E3E905,  5) + B;
	D = rotL(D + G(A, B, C) + words[ 2] + 0xFCEFA3F8,  9) + A;
	C = rotL(C + G(D, A, B) + words[ 7] + 0x676F02D9, 14) + D;
	B = rotL(B + G(C, D, A) + words[12] + 0x8D2A4C8A, 20) + C;
    }
    
    private static void roundThree()
    {
	A = rotL(A + H(B, C, D) + words[ 5] + 0xFFFA3942,  4) + B;
	D = rotL(D + H(A, B, C) + words[ 8] + 0x8771F681, 11) + A;
	C = rotL(C + H(D, A, B) + words[11] + 0x6D9D6122, 16) + D;
	B = rotL(B + H(C, D, A) + words[14] + 0xFDE5380C, 23) + C;

	A = rotL(A + H(B, C, D) + words[ 1] + 0xA4BEEA44,  4) + B;
	D = rotL(D + H(A, B, C) + words[ 4] + 0x4BDECFA9, 11) + A;
	C = rotL(C + H(D, A, B) + words[ 7] + 0xF6BB4B60, 16) + D;
	B = rotL(B + H(C, D, A) + words[10] + 0xBEBFBC70, 23) + C;

	A = rotL(A + H(B, C, D) + words[13] + 0x289B7EC6,  4) + B;
	D = rotL(D + H(A, B, C) + words[ 0] + 0xEAA127FA, 11) + A;
	C = rotL(C + H(D, A, B) + words[ 3] + 0xD4EF3085, 16) + D;
	B = rotL(B + H(C, D, A) + words[ 6] + 0x04881D05, 23) + C;

	A = rotL(A + H(B, C, D) + words[ 9] + 0xD9D4D039,  4) + B;
	D = rotL(D + H(A, B, C) + words[12] + 0xE6DB99E5, 11) + A;
	C = rotL(C + H(D, A, B) + words[15] + 0x1FA27CF8, 16) + D;
	B = rotL(B + H(C, D, A) + words[ 2] + 0xC4AC5665, 23) + C;
    }
    
    private static void roundFour()
    {
	A = rotL(A + I(B, C, D) + words[ 0] + 0xF4292244,  6) + B;
	D = rotL(D + I(A, B, C) + words[ 7] + 0x432AFF97, 10) + A;
	C = rotL(C + I(D, A, B) + words[14] + 0xAB9423A7, 15) + D;
	B = rotL(B + I(C, D, A) + words[ 5] + 0xFC93A039, 21) + C;
	
	A = rotL(A + I(B, C, D) + words[12] + 0x655B59C3,  6) + B;
	D = rotL(D + I(A, B, C) + words[ 3] + 0x8F0CCC92, 10) + A;
	C = rotL(C + I(D, A, B) + words[10] + 0xFFEFF47D, 15) + D;
	B = rotL(B + I(C, D, A) + words[ 1] + 0x85845DD1, 21) + C;
	
	A = rotL(A + I(B, C, D) + words[ 8] + 0x6FA87E4F,  6) + B;
	D = rotL(D + I(A, B, C) + words[15] + 0xFE2CE6E0, 10) + A;
	C = rotL(C + I(D, A, B) + words[ 6] + 0xA3014314, 15) + D;
	B = rotL(B + I(C, D, A) + words[13] + 0x4E0811A1, 21) + C;
	
	A = rotL(A + I(B, C, D) + words[ 4] + 0xF7537E82,  6) + B;
	D = rotL(D + I(A, B, C) + words[11] + 0xBD3AF235, 10) + A;
	C = rotL(C + I(D, A, B) + words[ 2] + 0x2AD7D2BB, 15) + D;
	B = rotL(B + I(C, D, A) + words[ 9] + 0xEB86D391, 21) + C;
    }

    private static void compute()
    {
	int AA, BB, CC, DD;
	
	AA = A;
	BB = B;
	CC = C;
	DD = D;
	
	roundOne();
	roundTwo();
	roundThree();
	roundFour();
	
	A += AA;
	B += BB;
	C += CC;
	D += DD;
    }
    
    public static void hashBuffer(byte in[])
    {
	long numBits;
	int endBlkLen, c, d;
	
	numBits = in.length * 8;
	endBlkLen = in.length % 64;

	A = 0x67452301;
	B = 0xEFCDAB89;
	C = 0x98BADCFE;
	D = 0x10325476;

	for(c = 0; c < in.length - endBlkLen; c += 16 * 4)
	    {
		for(d = 0; d < 16; d++)
			words[d] = 
			    ((in[c + (d * 4) + 0] & 0xff)      ) +
			    ((in[c + (d * 4) + 1] & 0xff) <<  8) + 
			    ((in[c + (d * 4) + 2] & 0xff) << 16) +
			    ((in[c + (d * 4) + 3] & 0xff) << 24);
		
		compute();
	    }

	/* c points to tail, with endBlkLen bytes left to hash */
	if(endBlkLen >= 56)
	    {
		/* not enough room, pad current block and add extra block */
		System.arraycopy(in, c, block, 0, endBlkLen);
		if(endBlkLen < 64)
		    {
			block[endBlkLen] = (byte) 0x80;
			for(d = endBlkLen + 1; d < 64; d++)
			    block[d] = 0;
		    }
		
		for(d = 0; d < 16; d++)
		    words[d] = 
			((block[(d * 4) + 0] & 0xff)      ) +
			((block[(d * 4) + 1] & 0xff) <<  8) + 
			((block[(d * 4) + 2] & 0xff) << 16) +
			((block[(d * 4) + 3] & 0xff) << 24);
		
		compute();

		/* last block */
		if(endBlkLen == 64)
			block[0] = (byte) 0x80; /* pad pattern */
		else
		    block[0] = 0;
		
		for(d = 1; d < 56; d++)
		    block[d] = 0; /* padding */

		/* bit count */
		block[56] = (byte) (numBits & 0xff); numBits >>= 8;
		block[57] = (byte) (numBits & 0xff); numBits >>= 8;
		block[58] = (byte) (numBits & 0xff); numBits >>= 8;
		block[59] = (byte) (numBits & 0xff); numBits >>= 8;
		block[60] = (byte) (numBits & 0xff); numBits >>= 8;
		block[61] = (byte) (numBits & 0xff); numBits >>= 8;
		block[62] = (byte) (numBits & 0xff); numBits >>= 8;
		block[63] = (byte) (numBits & 0xff);

		for(d = 0; d < 16; d++)
		    words[d] = 
			((block[(d * 4) + 0] & 0xff)      ) +
			((block[(d * 4) + 1] & 0xff) <<  8) + 
			((block[(d * 4) + 2] & 0xff) << 16) +
			((block[(d * 4) + 3] & 0xff) << 24);

		compute();
	    } else {
		/* add padding and bitcount to last block */
		System.arraycopy(in, c, block, 0, endBlkLen);

		/* pattern */
		block[endBlkLen] = (byte) 0x80;
		for(d = endBlkLen + 1; d < 56; d++)
		    block[d] = 0; /* padding */

		/* bit count */
		block[56] = (byte) (numBits & 0xff); numBits >>= 8;
		block[57] = (byte) (numBits & 0xff); numBits >>= 8;
		block[58] = (byte) (numBits & 0xff); numBits >>= 8;
		block[59] = (byte) (numBits & 0xff); numBits >>= 8;
		block[60] = (byte) (numBits & 0xff); numBits >>= 8;
		block[61] = (byte) (numBits & 0xff); numBits >>= 8;
		block[62] = (byte) (numBits & 0xff); numBits >>= 8;
		block[63] = (byte) (numBits & 0xff);
		
		for(d = 0; d < 16; d++)
		    words[d] = 
			((block[(d * 4) + 0] & 0xff)      ) +
			((block[(d * 4) + 1] & 0xff) <<  8) + 
			((block[(d * 4) + 2] & 0xff) << 16) +
			((block[(d * 4) + 3] & 0xff) << 24);
		
		compute();
	    }
    }
}
